const services = require('./services');

function index(req, res, next) {
  services.selectUsers({}, (users) => {
    res.status(200).json({ data: { users } })
  });
}

function show(req, res, next) {
  services.selectUser({ id: req.body.id }, (user) => {
    res.status(200).json({ data: { user } })
  });
}

function update(req, res, next) {
  services.selectUser({ id: req.body.id }, (user) => {
    services.updateUser(req.body.user, user, (user) => {
      res.status(200).json({ data: { user } })
    })
  });
}

function destroy(req, res, next) {
  services.selectUser({ id: req.body.id }, (user) => {
    services.updateUser({ active: false }, user, (user) => {
      res.status(200).json({ data: { user } })
    })
  });
}

module.exports = {
  index: index,
  show: show,
  update: update,
  destroy: destroy
};