const Collections = require('../../services/collections');
const User = require('./model');

//TODO: Populate with Profile

function selectUser(where, callback) {
  Collections.selectOne(User, where, null, null, (err, user) => {
    if (err) {
      //error handling
    } else {
      callback(user);
    }
  });
}

function selectUsers(where, callback) {
  Collections.selectRecords(User, where, null, null, (err, users) => {
    if (err) {
      //error handling
    } else {
      callback(users);
    }
  });
}

function saveUser(user, callback) {
  Collections.saveRecord(User, user, (err, user) => {
    if (err) {
      //error handling
      console.log(err);
    } else {
      callback(user);
    }
  });
}

function updateUser(where, user, callback) {
  Collections.updateRecord(User, where, user, null, (err, user) => {
    if (err) {
      //error handling
    } else {
      callback(user);
    }
  });
}

function deleteUser(where, callback) {
  Collections.deleteRecord(User, where, (err, user) => {
    if (err) {
      //error handling
    } else {
      callback(user);
    }
  });
}

module.exports = {
  selectUser: selectUser,
  selectUsers: selectUsers,
  saveUser: saveUser,
  updateUser: updateUser,
  deleteUser: deleteUser
};
