var _ = require('lodash');

const passport = require('passport');
const passportConf = require('../middlewares/passport');
const passportAuthJWT = passport.authenticate('jwt', { session: false });

const { publicRoutes } = require('../config/public_routes');

function verifyAuth(req, res, next) {
  if (!_.includes(publicRoutes, req.path)) {
    passportAuthJWT(req, res, next)
  } else {
    next();
  }
}

module.exports = {
  verifyAuth: verifyAuth
};