const passport = require('passport');
const FacebookTokenStrategy = require('passport-facebook-token');
const User = require('../api/user/services');

const {
    FACEBOOK_CLIENT_ID,
    FACEBOOK_SECRET
  } = require('../config/secrets');

//FACEBOOK OAUTH STRATEGY
passport.use('facebookToken', new FacebookTokenStrategy({
    clientID: FACEBOOK_CLIENT_ID,
    clientSecret: FACEBOOK_SECRET
  }, async (accessToken, refreshToken, profile, done) => {
    User.selectUser({ 'facebook.id': profile.id }, (user) => {
      if (user) {
        return done(null, user);
      } else {
        User.saveUser({
          method: 'facebook',
          facebook: {
            id: profile.id,
            email: profile.emails[0].value
          }
        }, (user) => {
          done(null, user);
        })
      }
    });
  }));