const passport = require('passport');
const GooglePlusTokenStrategy = require('passport-google-plus-token');
const User = require('../api/user/services');

const {
    GOOGLE_CLIENT_ID,
    GOOGLE_SECRET
} = require('../config/secrets');
  

//GOOGLE OAUTH STRATEGY
passport.use('googleToken', new GooglePlusTokenStrategy({
    clientID: GOOGLE_CLIENT_ID,
    clientSecret: GOOGLE_SECRET
  }, async (accessToken, refreshToken, profile, done) => {
    User.selectUser({ 'google.id': profile.id }, (user) => {
      if (user) {
        return done(null, user);
      } else {
        User.saveUser({
          method: 'google',
          google: {
            id: profile.id,
            email: profile.emails[0].value
          }
        }, (user) => {
          done(null, user);
        })
      }
    });
  }));