const passport = require('passport');
const LocalStrategy = require('passport-local').Strategy;
const User = require('../api/user/services');


// LOCAL STRATEGY
passport.use(new LocalStrategy({
    usernameField: 'email'
  }, async (email, password, done) => {
    User.selectUser({ 'local.email': email }, (user) => {
      if (!user) { return done(null, false); } else {
        user.isValidPassword(password, (success) => {
          if (!success) { return done(null, false); }
          done(null, user);
        });
      }
    })
  }));