const passport = require('passport');
const JwtStrategy = require('passport-jwt').Strategy;
const LocalStrategy = require('passport-local').Strategy;
const GooglePlusTokenStrategy = require('passport-google-plus-token');
const FacebookTokenStrategy = require('passport-facebook-token');

const { ExtractJwt } = require('passport-jwt');

const { JWT_SECRET } = require('../config/secrets');

const User = require('../api/user/services');
const LocalAuth = require('./local-auth');
const FacebookAuth = require('./facebook');
const GoogleAuth = require('./google');

// JSON WEB TOKENS STRATEGY
passport.use(new JwtStrategy({
  jwtFromRequest: ExtractJwt.fromHeader('authorization'),
  secretOrKey: JWT_SECRET
}, async (payload, done) => {
  // Find the user specified in token
  User.selectUser({ _id: payload.sub }, (user) => {
    if (!user) { return done(null, false); }
    return done(null, user);
  });
}));