function selectOne(collection, where, filter, options, callback) {
  let query = collection.findOne(where, filter)

  //begin option modifiers
  if (options && options.populate) query.populate(options.populate)
  //end option modifiers

  query.exec(callback)
}

function selectRecords(collection, where, filter, options, callback) {
  let query = collection.find(where, filter, callback)

  //begin option modifiers
  if (options && options.populate) query.populate(options.populate)
  //end option modifiers

  query.exec(callback)
}

function saveRecord(collection, record, callback) {
  let newRecord = new collection(record)
  newRecord.save(callback)
}

function updateRecord(collection, where, record, options, callback) {
  collection.update(where, record, options, callback)
}

function deleteRecord(collection, where, callback) {
  collection.remove(where, callback)
}

module.exports = {
  selectOne: selectOne,
  selectRecords: selectRecords,
  saveRecord: saveRecord,
  updateRecord: updateRecord,
  deleteRecord: deleteRecord
}